﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CRUD_LINQ
{
    public partial class Form1 : Form
    {
        employeeDataContext ed;
        public Form1()
        {
            InitializeComponent();
            ed = new employeeDataContext();
        }
        
        /// <summary>
        /// CODE TO ADD A RECORD INTO THE TABLE
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn_Save_Click(object sender, EventArgs e)
        {

            employee empTable = new employee(); // calling the employee class in the employee.designer.cs file
            empTable.EMP_ID = Int32.Parse(txtEmpId.Text); // Mapping the data to the column
            empTable.EMP_NAME = txtEmpName.Text.ToString(); // Mapping the data to the column
            empTable.EMP_DEPT = txtEmpDept.Text.ToString(); // Mapping the data to the column
            empTable.EMP_LOCATION = txtEmpLocation.Text.ToString(); // Mapping the data to the column
            ed.employees.InsertOnSubmit(empTable); // Inserting the record

            // If the below code is not given your data changes will not be reflected
            ed.SubmitChanges();  // This is very mandatory to get changes reflected in the database.
            MessageBox.Show("Record Inserted Successfully");
        }

        /// <summary>
        /// CODE TO DELETE RECORD FROM THE TABLE
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void btnDelete_Click(object sender, EventArgs e)
        {
            int empid = Int32.Parse(txtEmpId.Text);
            //Here "ed" is the  employeeDataContext
            employee emp = ed.employees.Single(e1 => e1.EMP_ID == empid); //To Retrieve one single record from the database for the given empid.

            if (emp != null)
            {
                ed.employees.DeleteOnSubmit(emp);
                ed.SubmitChanges();
                MessageBox.Show("Record Deleted");
            }
            
        }


        /// <summary>
        /// CODE TO UPDATE RECORD IN THE TABLE
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnUpdate_Click(object sender, EventArgs e)
        {
            int empid = Int32.Parse(txtEmpId.Text);
            employee emp = ed.employees.Single(e1 => e1.EMP_ID == empid); //To Retrieve one single record from the database for the given empid.

            emp.EMP_ID = Int32.Parse(txtEmpId.Text); // Mapping the data to the column in the table
            emp.EMP_NAME = txtEmpName.Text.ToString(); // Mapping the data to the column in the table
            emp.EMP_DEPT = txtEmpDept.Text.ToString(); // Mapping the data to the column in the table
            emp.EMP_LOCATION = txtEmpLocation.Text.ToString(); // Mapping the data to the column in the table            
            ed.SubmitChanges();
            MessageBox.Show("Record Updated");
        }

        /// <summary>
        /// CODE TO FIND A RECORD IN THE TABLE
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void btnFind_Click(object sender, EventArgs e)
        {
            int empid = Int32.Parse(txtEmpId.Text);

            var empresult = from data in ed.employees  // Ling Query to retrive data from table
                            where data.EMP_ID == empid
                            select data;            

            // Data Binding
            foreach (var emp in empresult)
            {
                txtEmpName.Text = emp.EMP_NAME.ToString(); // Retriving column data and binding to the textbox
                txtEmpLocation.Text = emp.EMP_LOCATION.ToString(); // Retriving column data and binding to the textbox
                txtEmpDept.Text = emp.EMP_DEPT.ToString(); // Retriving column data and binding to the textbox

            }
        }

        
    }
}
