﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CRUD_LINQ
{
    public partial class Form2 : Form
    {
        employeeDataContext ed;
        public Form2()
        {
            InitializeComponent();
            ed = new employeeDataContext();
        }

       
        /// <summary>
        /// CRUD_LINQ - CODE TO RETRIEVE RECORDS USING STORED PROC WITHOUT PARAMETER
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        
        private void btnStoredProc_Click(object sender, EventArgs e)
        {
            //Simplest Way
            dataGridView1.DataSource = ed.sp_GetDepartment(); // Calling the stored procedure
            //or
            //Other way of fetching the record
            IEnumerable<sp_GetDepartmentResult> query =
                 ed.sp_GetDepartment().ToList<sp_GetDepartmentResult>();

            MessageBox.Show("No of records fetched : " + query.Count().ToString());

            dataGridView1.DataSource = query;
        }


        /// <summary>
        /// CRUD_LINQ - CODE TO RETRIEVE RECORDS WITH OUT USING STORED PROC AND BINDING IT TO DATAGRID
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnFetchRecords_Click(object sender, EventArgs e)
        {
            var result = from emp in ed.employees
                         select emp;

            dataGridView1.DataSource = result.ToList<employee>();
        }

        /// <summary>
        /// CRUD_LINQ - CODE TO RETRIEVE RECORDS USING STORED PROC WITH PARAMETER 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnStoredProcWithParameter_Click(object sender, EventArgs e)
        {                       
            dataGridView1.DataSource = ed.sp_GetEmpDetail(6);
        }

        

        

        
    }
}
